import 'package:equatable/equatable.dart';

enum SpaceStatus {
  active,
  deleted,
  parentDeleted;

  static SpaceStatus getValueFromString(String value) => switch (value) {
        'active' => active,
        'deleted' => deleted,
        'parentDeleted' => parentDeleted,
        _ => active,
      };
}

class SpaceModel extends Equatable {
  final String uuid;
  final String spaceName;
  final String icon;
  final List<SpaceModel> children;
  final SpaceStatus status;

  const SpaceModel({
    required this.uuid,
    required this.spaceName,
    required this.icon,
    required this.children,
    required this.status,
  });

  factory SpaceModel.fromJson(Map<String, dynamic> json) {
    return SpaceModel(
      uuid: json['uuid'] as String,
      spaceName: json['spaceName'] as String,
      icon: json['icon'] as String,
      children: (json['children'] as List<dynamic>?)
              ?.map((e) => SpaceModel.fromJson(e as Map<String, dynamic>))
              .toList() ??
          [],
      status: SpaceStatus.getValueFromString(json['status'] as String),
    );
  }

  @override
  List<Object?> get props => [uuid, spaceName, icon, children];
}
