import 'package:flutter/material.dart';
import 'package:syncrow_web/pages/space_management_v2/modules/communities/domain/models/community_model.dart';
import 'package:syncrow_web/utils/extension/build_context_x.dart';

class SpaceManagementSidebarCommunitiesList extends StatefulWidget {
  const SpaceManagementSidebarCommunitiesList({
    required this.communities,
    required this.itemBuilder,
    super.key,
  });

  final List<CommunityModel> communities;
  final Widget Function(BuildContext context, int index) itemBuilder;

  @override
  State<SpaceManagementSidebarCommunitiesList> createState() =>
      _SpaceManagementSidebarCommunitiesListState();
}

class _SpaceManagementSidebarCommunitiesListState
    extends State<SpaceManagementSidebarCommunitiesList> {
  late final ScrollController _scrollController;

  @override
  void initState() {
    super.initState();
    _scrollController = ScrollController();
  }

  bool _onNotification(ScrollEndNotification notification) {
    final hasReachedEnd = notification.metrics.extentAfter == 0;
    if (hasReachedEnd) {
      // Call data from API.
      return true;
    }

    return false;
  }

  @override
  void dispose() {
    _scrollController
      ..removeListener(() {})
      ..dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SingleChildScrollView(
      scrollDirection: Axis.horizontal,
      child: SizedBox(
        width: context.screenWidth * 0.5,
        child: Scrollbar(
          scrollbarOrientation: ScrollbarOrientation.left,
          thumbVisibility: true,
          controller: _scrollController,
          child: NotificationListener<ScrollEndNotification>(
            onNotification: _onNotification,
            child: ListView.builder(
              shrinkWrap: true,
              padding: const EdgeInsetsDirectional.only(start: 16),
              itemCount: widget.communities.length,
              controller: _scrollController,
              itemBuilder: widget.itemBuilder,
            ),
          ),
        ),
      ),
    );
  }
}
